# Work Breakdown Structure: Milestone "FaaS"

Below is a work breakdown structure for the "FaaS" milestone.

```mermaid
gantt
    title EDP Milestone 'FaaS' Work Breakdown Structure
    dateFormat  YYYY-MM-DD
    axisFormat %d.%m.
    Begin OTC IaC                       :milestone, m1, 2025-05-02, 0m
    Begin observabiliy                  :milestone, m2, 2025-05-20, 0m
    Foundry Cluster ready               :milestone, m3, 2025-06-10, 1d
    FaaS Product ready                  :milestone, m4, 2025-07-16, 1d

    section Forgejo as a Service
    Create Kubernetes IaC Stack         :done, iac, after m1, until m3
    Observability                       :done, observability, after m2, until m3
    Runner Concept and implemenatation  :runner, after m3, 15d
    Secure Prod Env (WAF)               :secprod, after test-ressource, 5d

    section Test FaaS Service
    Test HA of central service          :test-ha, after m3, 12d
    Test HA of observability            :test-obs, after m3, 7d
    Deployment, accounting and billing concept for friendly user service consumption :deployment-concept, after m3, 12d
    Test secure Deployment/Destroyment  :test-ressource, after deployment-concept, 5d
    test day-2 operations :day-2, after test-ressource test-ha test-obs, 12d
    Test Customer Onboarding :onboarding, after deployment-concept, 5d

    section Check and document specified Product capabilities
    Create Template Apps                :apps, after m3, 15d
    Documentation                       :doc, after m3, 4d
    Project Mgmt                        :pm, after m3, 4d
    VCS                                 :vcs, after pm, 4d
    Branch Protection                   :vcsbranch, after vcs, 4d
    Registry                            :reg, after vcs, 4d
    Container Registry                  :ocireg, after reg, 4d
    Code review                         :cr, after vcs, 4d
    CI/CD                               :cicd, after runner, 8d
    Security Scanning                   :sec, after runner, 12d

    section Forgejo as Portal Frontend
    T Design Features                  :design, 2025-05-28, 23d
    Portal Frontend Architecture        :pfarch, after m3, 15d
    PF Dev Flow (inc.Forgejo Pipelines) : pfdev, after runner deployment-concept pfarch, 8d

    section Deployment
    Production Deployment               :proddeploy, after secprod day-2, 6d

```


![alt text](wps-annotations.jpg)